# vcenter_license – Manage VMware vCenter license keys

New in version 2.4.

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Add and delete vCenter, ESXi server license keys.

## Requirements

The below requirements are needed on the host that executes this module.

- pyVmomi

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
cluster_name string added in 2.9 |  | Name of the cluster to apply vSAN license.
datacenter string added in 2.9 |  | The datacenter name to use for the operation.
esxi_hostname string added in 2.8 |  | The hostname of the ESXi server to which the specified license will be assigned. This parameter is optional.
hostname string |  | The hostname or IP address of the vSphere vCenter server. If the value is not specified in the task, the value of environment variable `VMWARE_HOST` will be used instead. Environment variable supported added in Ansible 2.6.
labels dictionary | Default: {"source": "ansible"} | The optional labels of the license key to manage in vSphere vCenter. This is dictionary with key/value pair.
license string / required |  | The license key to manage in vSphere vCenter.
password string |  | The password of the vSphere vCenter server. If the value is not specified in the task, the value of environment variable `VMWARE_PASSWORD` will be used instead. Environment variable supported added in Ansible 2.6. aliases: pass, pwd
port integer added in 2.5 | Default: 443 | The port number of the vSphere vCenter server. If the value is not specified in the task, the value of environment variable `VMWARE_PORT` will be used instead. Environment variable supported added in Ansible 2.6.
proxy_host string added in 2.9 |  | Address of a proxy that will receive all HTTPS requests and relay them. The format is a hostname or a IP. If the value is not specified in the task, the value of environment variable `VMWARE_PROXY_HOST` will be used instead.
proxy_port integer added in 2.9 |  | Port of the HTTP proxy that will receive all HTTPS requests and relay them. If the value is not specified in the task, the value of environment variable `VMWARE_PROXY_PORT` will be used instead.

state
string

Choices:
- absent
- present ←

Whether to add (`present`) or remove (`absent`) the license key.

username string |  | The username of the vSphere vCenter server. If the value is not specified in the task, the value of environment variable `VMWARE_USER` will be used instead. Environment variable supported added in Ansible 2.6. aliases: admin, user

validate_certs
boolean

Choices:
- no
- yes ←

Allows connection when SSL certificates are not valid. Set to `false` when certificates are not trusted.
If the value is not specified in the task, the value of environment variable `VMWARE_VALIDATE_CERTS` will be used instead.
Environment variable supported added in Ansible 2.6.
If set to `yes`, please make sure Python >= 2.7.9 is installed on the given machine.

## Notes

Note

- This module will also auto-assign the current vCenter to the license key if the product matches the license key, and vCenter us currently assigned an evaluation license only.
- The evaluation license (00000-00000-00000-00000-00000) is not listed when unused.
- If `esxi_hostname` is specified, then will assign the `license` key to the ESXi host.

## Examples

    - name: Add a new vCenter license
      vcenter_license:
        hostname: '{{ vcenter_hostname }}'
        username: '{{ vcenter_username }}'
        password: '{{ vcenter_password }}'
        license: f600d-21ae3-5592b-249e0-cc341
        state: present
      delegate_to: localhost

    - name: Remove an (unused) vCenter license
      vcenter_license:
        hostname: '{{ vcenter_hostname }}'
        username: '{{ vcenter_username }}'
        password: '{{ vcenter_password }}'
        license: f600d-21ae3-5592b-249e0-cc341
        state: absent
      delegate_to: localhost

    - name: Add ESXi license and assign to the ESXi host
      vcenter_license:
        hostname: '{{ vcenter_hostname }}'
        username: '{{ vcenter_username }}'
        password: '{{ vcenter_password }}'
        esxi_hostname: '{{ esxi_hostname }}'
        license: f600d-21ae3-5592b-249e0-dd502
        state: present
      delegate_to: localhost

    - name: Add vSAN license and assign to the given cluster
      vcenter_license:
        hostname: '{{ vcenter_hostname }}'
        username: '{{ vcenter_username }}'
        password: '{{ vcenter_password }}'
        datacenter: '{{ datacenter_name }}'
        cluster_name: '{{ cluster_name }}'
        license: f600d-21ae3-5592b-249e0-dd502
        state: present
      delegate_to: localhost

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
licenses list | always | list of license keys after module executed Sample: ['f600d-21ae3-5592b-249e0-cc341', '143cc-0e942-b2955-3ea12-d006f']

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Dag Wieers (@dagwieers)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.